//=============================================================================
// File: ACPRD_MAIN.H - V1.00
// Rem.: The ACPRD Project Page on the Web -> http://hc12web.de/acprd
//=============================================================================

#ifndef __ACPRD_MAIN_H
#define __ACPRD_MAIN_H

//-- Includes -----------------------------------------------------------------

#include "t6963.h"						// text attribute defs

//-- Definitions --------------------------------------------------------------

#define BAUD_19K2_8000		26			//  19200Bd @  8MHz ECLK
#define BAUD_9600_24000		156			//   9600Bd @ 24MHz ECLK
#define BAUD_19K2_24000		78			//  19200Bd @ 24MHz ECLK
#define BAUD_115K2_24000	13			// 115200Bd @ 24MHz ECLK

#define SPIBD_500K_8000		0x03		// /16 -> 500kHz @  8MHz ECLK
#define SPIBD_500K_24000	0x23		// /48 -> 500kHz @ 24MHz ECLK

#define ACPRD_VPWR_MIN		(10 * 512)	// min voltage at atd0[6]
#define ACPRD_VBAT_MIN		(10 * 512)	// min voltage at atd0[7]

#define TA_NORMAL			0
#define TA_BLINK			(T6963_TA_BLINK << 8)
#define TA_REVERS			(T6963_TA_REVERS << 8)

//-- Datatype Definitions -----------------------------------------------------

//-- Extern Declarations ------------------------------------------------------

//-- Macros -------------------------------------------------------------------

//-- Function Prototypes ------------------------------------------------------

UINT8 checkAlarm(void);

#endif //__ACPRD_MAIN_H =======================================================

