//=============================================================================
// File: ACPRD_VECTORS.C - V1.00
// Rem.: The ACPRD Project Page on the Web -> http://hc12web.de/acprd
//=============================================================================

//-- function prototypes for Interrupt Service Routines -----------------------

#include "datatypes.h"
#include "acprd_timer.h"
#include "acprd_encoder.h"
#include "acprd_freqout.h"

#ifdef IMAGECRAFT_C
extern void _start(void);	// entry point in crt??.s
#endif
#ifdef METROWERKS_C
extern void _Startup( void );	// Entry point after Reset 
#endif

//-- Code ---------------------------------------------------------------------

#ifdef METROWERKS_C
interrupt
#endif
#ifdef IMAGECRAFT_C
#pragma interrupt_handler isrErrorHandler
#endif
void isrErrorHandler(void) {
	// place a breakpoint here to catch/debug unexpected interrupt events
	}

//-- Vector Table -------------------------------------------------------------

#ifdef IMAGECRAFT_C
#pragma abs_address:0xff80
void (*interrupt_vectors[])(void) = 
#endif
#ifdef METROWERKS_C
void (* const interrupt_vectors[])() @0xff80 = 
#endif

	{
	isrErrorHandler,   	// Reserved
	isrErrorHandler,   	// Reserved
	isrErrorHandler,   	// Reserved
	isrErrorHandler,   	// Reserved
	isrErrorHandler,   	// Reserved
	isrErrorHandler,   	// Reserved
	isrErrorHandler,   	// PWM Emergency Shutdown
	isrErrorHandler,   	// PORT P Interrupt
	isrErrorHandler,   	// CAN4 transmit
	isrErrorHandler,   	// CAN4 receive
	isrErrorHandler,   	// CAN4 errors
	isrErrorHandler,   	// CAN4 wake-up
	isrErrorHandler,   	// CAN3 transmit
	isrErrorHandler,   	// CAN3 receive
	isrErrorHandler,   	// CAN3 errors
	isrErrorHandler,   	// CAN3 wake-up
	isrErrorHandler,   	// CAN2 transmit
	isrErrorHandler,   	// CAN2 receive
	isrErrorHandler,   	// CAN2 errors
	isrErrorHandler,   	// CAN2 wake-up
	isrErrorHandler,   	// CAN1 transmit
	isrErrorHandler,   	// CAN1 receive
	isrErrorHandler,   	// CAN1 errors
	isrErrorHandler,   	// CAN1 wake-up
	isrErrorHandler,   	// CAN0 transmit
	isrErrorHandler,   	// CAN0 receive
	isrErrorHandler,   	// CAN0 errors
	isrErrorHandler,   	// CAN0 wake-up
	isrErrorHandler,   	// FLASH
	isrErrorHandler,   	// EEPROM
	isrErrorHandler,   	// SPI2
	isrErrorHandler,   	// SPI1
	isrErrorHandler,   	// IIC Bus
	isrErrorHandler,	// BDLC
	isrErrorHandler,   	// CRG Self Clock Mode
	isrErrorHandler,   	// CRG PLL Lock
	isrErrorHandler,   	// Pulse Accumulator B Overflow
	isrMDCU,    		// Modulus Down Counter underflow
	isrErrorHandler,   	// PORT H
	isrErrorHandler,   	// PORT J 
	isrErrorHandler,   	// ATD1
	isrErrorHandler,   	// ATD0
	isrErrorHandler,   	// SCI1 
	isrErrorHandler,   	// SCI0
	isrErrorHandler,   	// SPI0
	isrErrorHandler,   	// Pulse accumulator input edge
	isrErrorHandler,   	// Pulse accumulator A overflow
	isrErrorHandler,   	// Enhanced Capture Timer overflow
	isrErrorHandler,   	// Enhanced Capture Timer channel 7
	isrErrorHandler,   	// Enhanced Capture Timer channel 6
	isrErrorHandler,   	// Enhanced Capture Timer channel 5
	isrErrorHandler,   	// Enahnced Capture Timer channel 4
	isrErrorHandler,	// Enhanced Capture Timer channel 3
	isrOC2,     		// Enhanced Capture Timer channel 2
	isrIC1,     		// Enhanced Capture Timer channel 1
	isrIC0,     		// Enhanced Capture Timer channel 0
	isrErrorHandler,   	// Real Time Interrupt
	isrErrorHandler,   	// IRQ
	isrErrorHandler,   	// XIRQ
	isrErrorHandler,   	// SWI
	isrErrorHandler,   	// Unimplemented instruction trap
	isrErrorHandler,   	// COP failure Reset
	isrErrorHandler,   	// Clock Monitor fail reset
#ifdef IMAGECRAFT_C
	_start				// RESET
#endif
#ifdef METROWERKS_C
	_Startup			// RESET
#endif
	};


#ifdef IMAGECRAFT_C
#pragma end_abs_address
#endif

//=============================================================================

