//=============================================================================
// File: S12_SCI.C - V1.00
// Rem.: The ACPRD Project Page on the Web -> http://hc12web.de/acprd
//=============================================================================

//-- Includes -----------------------------------------------------------------

#include "datatypes.h"
#include "hcs12dp256.h"
#include "s12_sci.h"

//-- Code ---------------------------------------------------------------------

void initSCI0(UINT16 bauddiv) {

	SCI0BD  = bauddiv & 0x1fff;	// baudrate divider has 13 bits
	SCI0CR1 = 0;				// mode = 8N1
	SCI0CR2 = BM_TE+BM_RE;		// Transmitter + Receiver enable
	}

//-----------------------------------------------------------------------------

UINT8 getSCI0(void) {

	while((SCI0SR1 & BM_RDRF) == 0) ;
	return SCI0DRL;
	}

//-----------------------------------------------------------------------------

void putSCI0(UINT8 c) {

	while((SCI0SR1 & BM_TDRE) == 0) ;
	SCI0DRL = c;
	}

//-- same as above, but SCI1 --------------------------------------------------

void initSCI1(UINT16 bauddiv) {

	SCI1BD  = bauddiv & 0x1fff;	// baudrate divider has 13 bits
	SCI1CR1 = 0;				// mode = 8N1
	SCI1CR2 = BM_TE+BM_RE;		// Transmitter + Receiver enable
	}

//-----------------------------------------------------------------------------

UINT8 getSCI1(void) {

	while((SCI1SR1 & BM_RDRF) == 0) ;
	return SCI1DRL;
	}

//-----------------------------------------------------------------------------

void putSCI1(UINT8 c) {

	while((SCI1SR1 & BM_TDRE) == 0) ;
	SCI1DRL = c;
	}

//=============================================================================

