//=============================================================================
// File: S12_SPI.C - V1.00
// Rem.: The ACPRD Project Page on the Web -> http://hc12web.de/acprd
//=============================================================================

//-- Includes -----------------------------------------------------------------

#include "datatypes.h"
#include "hcs12dp256.h"
#include "s12_spi.h"

//-- Code ---------------------------------------------------------------------

void initSPI0(UINT8 bauddiv, UINT8 cpol, UINT8 cpha) {

	DDRS |= 0xe0;						// SS,SCK,MOSI Output
	SPI0BR = bauddiv;					// set SPI Rate
	// enable SPI, Master Mode, select clock polarity/phase
	SPI0CR1 = BM_SPE | BM_MSTR | (cpol ? BM_CPOL : 0) | (cpha ? BM_CPHA : 0);
	SPI0CR2 = 0;						// as default
	}

//-----------------------------------------------------------------------------

UINT8 xferSPI0(UINT8 abyte) {

	SPI0DR = abyte;						// start transfer
	while((SPI0SR & BM_SPIF) == 0) ;	// wait until transfer finished
	return(SPI0DR);						// read back data received
	}

//=============================================================================
