//=============================================================================
// File: T6963.H - V1.00
// Rem.: The ACPRD Project Page on the Web -> http://hc12web.de/acprd
//=============================================================================

#ifndef __T6963_H
#define __T6963_H

//-- Definitions --------------------------------------------------------------

//----------------------
// Hardware dependencies
//----------------------

// data port assignments
#define T6963_DPORT		PTP
#define T6963_DDDR		DDRP

// control port assignments
#define T6963_CPORT		PTT
#define T6963_CDDR		DDRT
#define T6963_WR		0x10			// write
#define T6963_RD		0x20			// read
#define T6963_CE		0x40			// enable
#define T6963_CD		0x80			// cmd/data

// block copy transfer modes
#define T6963_RAWMODE	0
#define T6963_TEXTMODE	1
#define T6963_ATTRMODE	2

// text attribute codes
#define T6963_TA_BLINK	0x08
#define T6963_TA_REVERS	0x05

//---------------------
// Display dependencies
//---------------------

// Usable display area
#define T6963_TMAXX		40				// text columns
#define T6963_TMAXY		8				// text rows
#define T6963_GMAXX		240				// pixel columns
#define T6963_GMAXY		64				// pixel rows

// Internal memory organization
#define T6963_TBASE		0x0000			// text memory base address
#define T6963_TCOLS		40				// text columns (bytes per row)
#define T6963_TROWS		8				// text rows
#define T6963_TSIZE		(T6963_TCOLS * T6963_TROWS)	// text memory size

#define T6963_GBASE		0x0200			// graphics memory base address
#define T6963_GCOLS		40				// graphics columns (bytes per row)
#define T6963_GROWS		64				// graphics rows
#define T6963_GSIZE		(T6963_GCOLS * T6963_GROWS)	// graphics memory size

#define T6963_CGBASE	0x1800			// CG RAM base address
#define T6963_CGSIZE	0x0800			// CG RAM size (256 * 8)


//-- Extern Declarations ------------------------------------------------------

//-- Function Prototypes ------------------------------------------------------

void initT6963(const UINT8 *font);
void refreshT6963c(void *tbuf);
void refreshT6963a(void *tbuf);

#endif //__T6963_H ============================================================

